<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * Script file of miniorange otp verification.
 *
 * @copyright   Copyright (C) 2005 - 2018 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */
class pkg_MINIORANGEOTPVERIFICATIONInstallerScript
{
    /**
     * This method is called after a component is installed.
     *
     * @param  \stdClass $parent - Parent object calling this method.
     *
     * @return void
     */
    public function install($parent) 
    {

    }

    /**
     * This method is called after a component is uninstalled.
     *
     * @param  \stdClass $parent - Parent object calling this method.
     *
     * @return void
     */
    public function uninstall($parent) 
    {
        //echo '<p>' . JText::_('COM_HELLOWORLD_UNINSTALL_TEXT') . '</p>';
    }

    /**
     * This method is called after a component is updated.
     *
     * @param  \stdClass $parent - Parent object calling object.
     *
     * @return void
     */
    public function update($parent) 
    {
        //echo '<p>' . JText::sprintf('COM_HELLOWORLD_UPDATE_TEXT', $parent->get('manifest')->version) . '</p>';
    }

    /**
     * Runs just before any installation action is performed on the component.
     * Verifications and pre-requisites should run in this function.
     *
     * @param  string    $type   - Type of PreFlight action. Possible values are:
     *                           - * install
     *                           - * update
     *                           - * discover_install
     * @param  \stdClass $parent - Parent object calling object.
     *
     * @return void
     */
    public function preflight($type, $parent) 
    {
        //echo '<p>' . JText::_('COM_HELLOWORLD_PREFLIGHT_' . $type . '_TEXT') . '</p>';
    }

    /**
     * Runs right after any installation action is performed on the component.
     *
     * @param  string    $type   - Type of PostFlight action. Possible values are:
     *                           - * install
     *                           - * update
     *                           - * discover_install
     * @param  \stdClass $parent - Parent object calling object.
     *
     * @return void
     */
    function postflight($type, $parent) 
    {
       if ($type == 'uninstall') {
        return true;
        }
       $this->showInstallMessage('');
    }

    protected function showInstallMessage($messages=array()) {
        ?>
        <style>
        
	.mo-row {
		width: 100%;
		display: block;
		margin-bottom: 2%;
	}

	.mo-row:after {
		clear: both;
		display: block;
		content: "";
	}
    </style>
        <?php
            $lang =JFactory::getApplication()->getLanguage();
            $lang->load('pkg_miniorangeotpverification',JPATH_ROOT);
            $lang->load('com_joomlaotp',JPATH_ROOT);
            echo JText::_('COM_INSTALLATION_MSG');
        ?>

    	<div class="mo-row">
            <a class="btn btn-secondary" style="background-color: #226a8b; color : white" href="index.php?option=com_joomlaotp&view=accountsetup&tab-panel=account"><?php echo JText::_('COM_MINIORANGE_START_USING_OTP_PLUGIN');?></a>
            <a class="btn btn-secondary" style="background-color: #226a8b; color : white" href="https://plugins.miniorange.com/otp-verification-joomla" target="_blank"><?php echo JText::_('COM_MINIORANGE_READ_MINIORANGE_DOCUMENTS');?></a>
		    <a class="btn btn-secondary" style="background-color: #226a8b; color : white" href="https://www.miniorange.com/contact" target="_blank"><?php echo JText::_('COM_MINIORANGE_GET_SUPPORT');?></a>
        </div>
        <?php
    }
  
}