<?php

/**
 * @package     Joomla.User
 * @subpackage  plg_user_miniorangesendotp
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
$lang = JFactory::getLanguage();
$lang->load('plg_user_miniorangesendotp', JPATH_ADMINISTRATOR);


/**
 * This is the constant class which lists all the messages
 * to be shown in the plugin.
 */
class MoMessages
{
    function __construct()
    {
        //created an array instead of messages instead of constant variables for Translation reasons.
        define("MO_MESSAGES", serialize( array(
            //General Messages
            "OTP_SENT_PHONE" 		 => JText::_('PLG_USER_CONSTANT_OTP_SENT_PHONE') ,
            "OTP_SENT_EMAIL" 		 => JText::_('PLG_USER_CONSTANT_OTP_SENT_EMAIL') ,
            "OTP_SENT_EMAIL_OR_PHONE"=> JText::_('PLG_USER_CONSTANT_OTP_SENT_EMAIL_OR_PHONE') ,
            "ERROR_OTP_EMAIL" 		 => JText::_('PLG_USER_CONSTANT_ERROR_OTP_EMAIL') ,
            "ERROR_OTP_PHONE" 		 => JText::_('PLG_USER_CONSTANT_ERROR_OTP_PHONE') ,
            "ERROR_OTP_EMAIL_OR_PHONE"=>JText::_('PLG_USER_CONSTANT_ERROR_OTP_EMAIL_OR_PHONE'),
            "ERROR_PHONE_FORMAT" 	 => JText::_('PLG_USER_CONSTANT_ERROR_PHONE_FORMAT') ,
            "CHOOSE_METHOD" 		 => JText::_('PLG_USER_CONSTANT_CHOOSE_METHOD') ,
            "ERROR_PHONE_BLOCKED"	 => JText::_('PLG_USER_CONSTANT_ERROR_PHONE_BLOCKED') ,
            "ERROR_EMAIL_BLOCKED"	 => JText::_('PLG_USER_CONSTANT_ERROR_EMAIL_BLOCKED') ,
            "EMAIL_FORMAT"	         => JText::_('PLG_USER_CONSTANT_EMAIL_FORMAT') ,
            "COMMON_MESSAGES"        => JText::_('PLG_USER_CONSTANT_COMMON_MSG'),

            //License Messages
            "UPGRADE_MSG" 			 => JText::_('PLG_USER_UPGRADE_MSG') ,
            "FREE_PLAN_MSG" 		 => JText::_('PLG_USER_FREE_PLAN_MSG') ,
        )));
    }

    /**
     * This function is used to fetch and process the Messages to
     * be shown to the user. It was created to mostly show dynamic
     * messages to the user.
     */
    public static function showMessage($messageKeys , $data=array())
    {
        $displayMessage = "";
        $messageKeys = explode(" ",$messageKeys);
        $messages = unserialize(MO_MESSAGES);
        foreach ($messageKeys as $messageKey)
        {
            if(MoUtility::isBlank($messageKey)) return $displayMessage;
            $formatMessage = $messages[$messageKey];
            foreach($data as $key => $value)
            {
                $formatMessage = str_replace("{{" . $key . "}}", $value ,$formatMessage);
            }
            $displayMessage.=$formatMessage;
        }
        return $displayMessage;
    }
}
new MoMessages;